#!/bin/bash

# This script reads filenames from STDIN and outputs any relevant provides
# information that needs to be included in the package.

filelist=`sed "s/['\"]/\\\&/g"`

solist=$(echo "$filelist" | egrep -v "^/lib/ld\.so|/usr/lib(64)?/gcj/" | egrep '(/usr(/X11R6)?)?/lib(64)?/.*\.so' | \
	xargs file -L 2>/dev/null | grep "ELF.*shared object" | cut -d: -f1)
pythonlist=
tcllist=
rubygemlist=$(echo "$filelist"| egrep "\.gemspec$")                                                                                                         
mavenlist=$(echo "$filelist" |egrep '/usr/share/maven-fragments/*')
osgilist=$(echo "$filelist" |egrep "^(.*\.jar|((/usr/lib(64)|/usr/share).*/MANIFEST.MF))")

# fix parsing output of objdump when localized (mga#7883):
export LC_ALL=C

#
# --- Alpha does not mark 64bit dependencies
case `uname -m` in
  alpha*)	mark64="" ;;
  *)		mark64="()(64bit)" ;;
esac

#
# --- Library sonames and weak symbol versions (from glibc).
for f in $solist; do
    soname=$(objdump -p $f 2>/dev/null | awk '/SONAME/ {print $2}')

    lib64=`if file -L $f 2>/dev/null | \
	grep "ELF 64-bit" >/dev/null; then echo "$mark64"; fi`
    if [ "$soname" != "" ]; then
	if [ ! -L $f ]; then
	    echo $soname$lib64
	    objdump -p $f 2>/dev/null | awk '
		BEGIN { START=0 ; }
		/Version definitions:/ { START=1; }
		/^[0-9]/ && (START==1) { print $4; }
		/^$/ { START=0; }
	    ' | \
		grep -v $soname | \
		while read symbol ; do
		    echo "$soname($symbol)`echo $lib64 | sed 's/()//'`"
		done
	fi
    else
	echo ${f##*/}$lib64
    fi
done | sort -u

#
# --- If libperl.so is found in buildroot, we provide perlapi-<version>
if [ -n "`echo $filelist | grep -e '/CORE/libperl\.so'`" ]; then
    for i in $filelist; do
        if [ -n "`echo $i | grep -e '/CORE/libperl\.so\$'`" ]; then
            perlpath=$i
            version=${i/CORE*/}
            version=$(echo $version| sed -e 's!/$!!' -e 's!/[^/]*$!!' -e 's!.*/!!')
            minor=$(echo $version| sed -e 's!^.*\.!!')
            major=$(echo $version| sed -e 's!\.[0-9]*$!!')
            if [ -n "$version" ] && [ -n "$minor" ]; then
               for i in $(seq 0 $minor); do echo "perlapi-$major.$i"; done
            fi
        fi
    done
fi

#
# --- Perl modules.
[ -x /usr/lib/rpm/mageia/perl.prov ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/perl.prov | grep 'perl([[:upper:]]' | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/perl.prov failed' >&2 && exit 1

#
# --- Python modules.
[ -x /usr/lib/rpm/mageia/pythoneggs.py -a -n "$filelist" ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/pythoneggs.py --provides | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/pythoneggs.py failed' >&2 && exit 1

#
# --- Tcl modules.
[ -x /usr/lib/rpm/mageia/tcl.prov -a -n "$tcllist" ] &&
    echo "$tcllist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/tcl.prov | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/tcl.prov failed' >&2 && exit 1

#
# --- Php modules.
[ -x /usr/lib/rpm/mageia/php.prov ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/php.prov | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/php.prov failed' >&2 && exit 1

#
# --- Kernel modules.
[ -x /usr/lib/rpm/mageia/kmod.prov ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/kmod.prov | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/kmod.prov failed' >&2 && exit 1

#
# --- Pkgconfig deps
[ -x /usr/lib/rpm/mageia/pkgconfigdeps.sh ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/pkgconfigdeps.sh -P | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/pkgconfigdeps.sh failed' >&2 && exit 1

#
# --- mimehandler
[ -x /usr/lib/rpm/desktop-file.prov ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/desktop-file.prov --provides | sort -u \
        && test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/desktop-file.prov failed' >&2 && exit 1

#
# --- fonts
[ -x /usr/lib/rpm/fontconfig.prov ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/fontconfig.prov --provides | sort -u

#
# --- typelib() gobject-introspection bindings
[ -x /usr/lib/rpm/mageia/gi-find-deps.sh ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/gi-find-deps.sh -P | sort -u \
        && test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/gi-find-deps.sh failed' >&2 && exit 1

if [ -n "$LIBTOOLDEP" ]; then
#
# --- libtooldep deps
[ -x /usr/lib/rpm/libtooldeps.sh ] &&
    echo "$filelist" | tr '[:blank:]' \\n | /usr/lib/rpm/libtooldeps.sh -P | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/libtooldeps.sh failed' >&2 && exit 1

fi

#
# --- Ruby gems
[ -x /usr/bin/ruby -a -x /usr/lib/rpm/mageia/rubygems.rb -a -n "$rubygemlist" ] &&
    echo $rubygemlist | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/rubygems.rb --provides | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/rubygems.rb failed' >&2 && exit 1

#
# --- .so files.
for i in `echo $filelist | tr '[:blank:]' "\n" | egrep '(/usr(/X11R6)?)?/lib(|64)(/gcc(-lib)?/.+)?/[^/]+\.so$'`; do
    objd=`objdump -p ${i} | grep SONAME`
    [ -h ${i} -a -n "${objd}" ] && \
    lib64=`if file -L $i 2>/dev/null | grep "ELF 64-bit" >/dev/null; then echo "(64bit)"; fi` && \
    echo ${objd} | perl -p -e "s/.*SONAME\s+(\S+)\.so.*/devel(\1$lib64)/g"
done | sort -u

#
# --- mono provides
if [ -x /usr/bin/mono-find-provides ]; then
echo $filelist | tr '[:blank:]' '\n' | /usr/bin/mono-find-provides \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/bin/mono-find-provides failed' >&2 && exit 1
fi


#
# --- haskell provides
if [ -x /usr/bin/haskell-find-provides ]; then
echo $filelist | tr '[:blank:]' '\n' | /usr/bin/haskell-find-provides \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/bin/haskell-find-provides failed' >&2 && exit 1
fi

#
# --- gstreamer modules.
[ -x /usr/lib/rpm/mageia/gstreamer.prov ] &&
    echo "$solist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/gstreamer.prov | sort -u \
    	&& test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/gstreamer.prov failed' >&2 && exit 1

[ -x /usr/lib/rpm/mageia/gstreamer1.0.prov ] &&
    echo "$solist" | tr '[:blank:]' \\n | /usr/lib/rpm/mageia/gstreamer1.0.prov | sort -u \
        && test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/mageia/gstreamer1.0.prov failed' >&2 && exit 1

#
# --- osgi provides
if [ -x /usr/lib/rpm/osgi.prov ];then
  if [ ! -z "$osgilist" ]; then
    echo "$osgilist" | tr '[:blank:]' '\n' | /usr/lib/rpm/osgi.prov \
      && test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/osgi.prov failed' >&2 && exit 1
  fi
fi

#
# --- maven provides
if [ -x /usr/lib/rpm/maven.prov ];then
  if [ ! -z "$mavenlist" ]; then
    echo "$mavenlist" | tr '[:blank:]' '\n' | /usr/lib/rpm/maven.prov \
        && test ${PIPESTATUS[2]} -ne 0 && echo 'error: /usr/lib/rpm/maven.prov failed' >&2 && exit 1
  fi
fi

exit 0
